/**
 * @fileoverview added by tsickle
 * Generated from: cloned-document-resource.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
import { Resource } from './resource';
import { isClonedResource } from './interfaces/cloned-resource';
import { isEqual } from 'lodash-es';
export class ClonedDocumentResource {
    /**
     * @param {?} cloned_resource
     * @param {?} parent_resource
     * @param {?=} params
     */
    constructor(cloned_resource, parent_resource, params) {
        // calling toObject two times because we need different objects
        if (parent_resource instanceof Resource) {
            this.parent_resource_object = parent_resource.toObject(params);
        }
        else {
            this.parent_resource_object = { data: parent_resource };
        }
        if (isClonedResource(cloned_resource)) {
            this.resource_object = cloned_resource.superToObject(params);
        }
        else {
            this.resource_object = { data: cloned_resource };
        }
        this.removeDuplicatedAttributes();
        this.removeDuplicatedRelationships();
        this.removeDuplicatedIncludes();
    }
    /**
     * @return {?}
     */
    getResourceObject() {
        return this.resource_object;
    }
    /**
     * @private
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    removeDuplicatedIncludes() {
        if (!(/** @type {?} */ (this)).resource_object.included || !(/** @type {?} */ (this)).parent_resource_object.included) {
            return (/** @type {?} */ (this));
        }
        /** @type {?} */
        let parent_included = (/** @type {?} */ (this)).parent_resource_object.included;
        (/** @type {?} */ (this)).resource_object.included = (/** @type {?} */ (this)).resource_object.included.filter((/**
         * @param {?} included_resource
         * @return {?}
         */
        included_resource => {
            return !isEqual(included_resource, parent_included.find((/**
             * @param {?} include
             * @return {?}
             */
            include => include.id === included_resource.id)));
        }));
        (/** @type {?} */ (this)).resource_object.included = (/** @type {?} */ (this)).resource_object.included.map((/**
         * @param {?} included
         * @return {?}
         */
        included => {
            if (!parent_included.find((/**
             * @param {?} include
             * @return {?}
             */
            include => include.id === included.id))) {
                return included;
            }
            return new ClonedDocumentResource(included, parent_included.find((/**
             * @param {?} include
             * @return {?}
             */
            include => include.id === included.id))).getResourceObject()
                .data;
        }));
        return (/** @type {?} */ (this));
    }
    /**
     * @private
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    removeDuplicatedRelationships() {
        if (!(/** @type {?} */ (this)).resource_object.data.relationships || !(/** @type {?} */ (this)).parent_resource_object.data.relationships) {
            return (/** @type {?} */ (this));
        }
        for (let relationship in (/** @type {?} */ (this)).resource_object.data.relationships) {
            if (isEqual((/** @type {?} */ (this)).resource_object.data.relationships[relationship], (/** @type {?} */ (this)).parent_resource_object.data.relationships[relationship])) {
                delete (/** @type {?} */ (this)).resource_object.data.relationships[relationship];
            }
        }
        return (/** @type {?} */ (this));
    }
    /**
     * @private
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    removeDuplicatedAttributes() {
        if (!(/** @type {?} */ (this)).resource_object.data.attributes || !(/** @type {?} */ (this)).parent_resource_object.data.attributes) {
            return (/** @type {?} */ (this));
        }
        for (let attribute in (/** @type {?} */ (this)).resource_object.data.attributes) {
            if ((/** @type {?} */ (this)).resource_object.data.attributes[attribute] === (/** @type {?} */ (this)).parent_resource_object.data.attributes[attribute]) {
                delete (/** @type {?} */ (this)).resource_object.data.attributes[attribute];
            }
        }
        return (/** @type {?} */ (this));
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    ClonedDocumentResource.prototype.resource_object;
    /**
     * @type {?}
     * @private
     */
    ClonedDocumentResource.prototype.parent_resource_object;
}
//# sourceMappingURL=cloned-document-resource.js.map