/**
 * @fileoverview added by tsickle
 * Generated from: cloned-resource.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
import { Resource } from './resource';
import { ClonedDocumentResource } from './cloned-document-resource';
import { cloneDeep } from 'lodash-es';
/**
 * @template T
 */
export class ClonedResource extends Resource {
    /**
     * @param {?} resource
     */
    constructor(resource) {
        super();
        // @note using cloneDeep because the parent may have changed since clone (example: data received from socket while editing clone)
        this.parent = cloneDeep(resource);
        this.type = this.parent.type; // this line should go to fill method?
        delete this.relationships; // remove empty relationships object so fill method creates them... how can we improve inheritance to remove this?
        // remove empty relationships object so fill method creates them... how can we improve inheritance to remove this?
        /** @type {?} */
        let include = Object.keys(this.parent.relationships);
        this.fill(this.parent.toObject({ include: include }));
        this.copySourceFromParent();
    }
    /**
     * @param {?=} params
     * @return {?}
     */
    toObject(params) {
        return new ClonedDocumentResource(this, this.parent, params).getResourceObject();
    }
    /**
     * @param {?=} params
     * @return {?}
     */
    superToObject(params) {
        return super.toObject(params);
    }
    /**
     * @private
     * @return {?}
     */
    copySourceFromParent() {
        this.source = this.parent.source;
        for (let relationship in this.relationships) {
            this.relationships[relationship].source = this.parent.relationships[relationship].source;
        }
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    ClonedResource.prototype.parent;
    /** @type {?} */
    ClonedResource.prototype.attributes;
    /** @type {?} */
    ClonedResource.prototype.relationships;
}
//# sourceMappingURL=cloned-resource.js.map